var q = Object.defineProperty;
var Y = (o, s, t) => s in o ? q(o, s, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[s] = t;
var h = (o, s, t) => (Y(o, typeof s != "symbol" ? s + "" : s, t), t);
import { PlotController as j, CursorType as M, newScreenPoint as k, OxyModifierKeys as I, OxyMouseButton as b, LineJoin as O, FontWeights as L, OxySize as z, ClippingRenderContext as J, round as R, isNullOrUndef as E, HorizontalAlignment as T, VerticalAlignment as C, StringHelper as K, OxyRect as S, OxyColor as W, OxyColors as $, EdgeRenderingMode as G, ScreenPoint_LeftTop as Q, SvgRenderContext as H } from "oxyplot-js";
import { jsPDF as U } from "jspdf";
class V {
  constructor() {
    h(this, "controller");
    h(this, "defaultController");
    h(this, "_zoomRectangle");
    h(this, "_model");
    h(this, "_isModelInvalidated", !1);
    h(this, "_updateDataFlag", !1);
    h(this, "_rendering", !1);
  }
  get actualController() {
    return this.controller ? this.controller : this.defaultController ? this.defaultController : (this.defaultController = new j(), this.defaultController);
  }
  get actualModel() {
    return this._model;
  }
  get model() {
    return this._model;
  }
  set model(s) {
    const t = this._model;
    this._model = s, this.onModelChanged(t, s);
  }
  onModelChanged(s, t) {
    s && s.attachPlotView(void 0), t && t.attachPlotView(this), this.invalidatePlot(!0);
  }
  invalidatePlot(s) {
    this._isModelInvalidated = !0, this._updateDataFlag = s || !1, this.render();
  }
  render() {
    const s = this._model;
    s && (this._isModelInvalidated && (s.update(this._updateDataFlag), this._isModelInvalidated = !1, this._updateDataFlag = !1), window.requestAnimationFrame(async () => this.renderSync()));
  }
  setClipboardText(s) {
    try {
      navigator.clipboard.writeText(s);
    } catch (t) {
      console.error(t);
    }
  }
  setCursorType(s) {
  }
  hideTracker() {
  }
  showTracker(s) {
  }
  hideZoomRectangle() {
    this._zoomRectangle = void 0;
  }
  showZoomRectangle(s) {
    this._zoomRectangle = s;
  }
  async renderSync() {
    if (this._model && !this._rendering) {
      this._rendering = !0;
      try {
        await this.renderOverride(this._model);
      } finally {
        this._rendering = !1;
      }
    }
  }
}
function P(o) {
  return {
    position: k(o.offsetX, o.offsetY),
    modifierKeys: it(o),
    handled: !1
  };
}
function tt(o) {
  const s = P(o);
  return s.clickCount = o.detail, s.changedButton = st(o), s;
}
function et(o) {
  const s = P(o);
  return s.delta = o.deltaY != 0 ? -o.deltaY : o.deltaX, s;
}
function it(o) {
  let s = I.None;
  return o.ctrlKey && (s |= I.Control), o.shiftKey && (s |= I.Shift), o.altKey && (s |= I.Alt), o.metaKey && (s |= I.Windows), s;
}
function st(o) {
  return o.button === 0 ? b.Left : o.button === 1 ? b.Middle : o.button === 2 ? b.Right : o.button === 3 ? b.XButton1 : o.button === 4 ? b.XButton2 : b.None;
}
function X(o) {
  switch (o) {
    case M.Default:
      return "default";
    case M.Pan:
      return "grab";
    case M.ZoomRectangle:
      return "nwse-resize";
    case M.ZoomHorizontal:
      return "ew-resize";
    case M.ZoomVertical:
      return "ns-resize";
    default:
      return "default";
  }
}
function Z(o, s) {
  o.addEventListener("contextmenu", function(t) {
    t.preventDefault();
  }), new ResizeObserver(() => {
    s.invalidatePlot(!1);
  }).observe(o), o.onmousedown = (t) => {
    s.actualController.handleMouseDown(s, tt(t));
  }, o.onmousemove = (t) => {
    s.actualController.handleMouseMove(s, P(t));
  }, o.onmouseup = (t) => {
    s.actualController.handleMouseUp(s, P(t));
  }, o.onmouseenter = (t) => {
    s.actualController.handleMouseEnter(s, P(t));
  }, o.onmouseleave = (t) => {
    s.actualController.handleMouseLeave(s, P(t));
  }, o.onwheel = (t) => {
    s.actualController.handleMouseWheel(s, et(t));
  };
}
let F = null;
function nt() {
  if (F)
    return F;
  const o = document.createElement("canvas");
  if (F = o == null ? void 0 : o.getContext("2d"), !F)
    throw new Error("Could not get canvas context");
  return F;
}
let D = null;
const ot = (o, s, t) => (D || (D = new B()), D.convertFont(o, s, t || L.Normal));
function N(o) {
  o = o || nt();
  function s(t, e, i, n) {
    if (!o)
      throw new Error("Could not get canvas context");
    o.font = ot(e, i, n);
    const r = o.measureText(t);
    return new z(r.width, i);
  }
  return {
    measureText: s
  };
}
class B {
  convertLineJoin(s) {
    switch (s = s || O.Miter, s) {
      case O.Miter:
        return "miter";
      case O.Bevel:
        return "bevel";
      case O.Round:
        return "round";
    }
  }
  convertStrokeOrFillStyle(s) {
    return s.toRgba();
  }
  convertFont(s, t, e) {
    let i = "";
    return (e || L.Normal) > L.Normal && (i += "bold "), i += `${t || 12}px `, s && (i += `"${s}" `), i.trim();
  }
}
class rt {
  constructor() {
    h(this, "cache", /* @__PURE__ */ new Map());
  }
  get(s) {
    return this.cache.get(s);
  }
  set(s, t) {
    this.cache.set(s, t);
  }
  clear(s) {
    s ? this.cache.delete(s) : this.cache.clear();
  }
}
let A = new rt();
function lt() {
  return A;
}
function yt(o) {
  A = o;
}
class at extends J {
  constructor(t) {
    super();
    h(this, "ctx");
    h(this, "_textMeasurer");
    h(this, "styleConverter", new B());
    h(this, "_ctxInitStyles");
    h(this, "_renderContextImageCacheService");
    this.canvas = t;
    const e = t.getContext("2d");
    if (!e)
      throw new Error("Could not get canvas context");
    this.ctx = e, this._ctxInitStyles = {
      fillStyle: e.fillStyle,
      strokeStyle: e.strokeStyle,
      lineJoin: e.lineJoin,
      lineWidth: e.lineWidth
    }, this._renderContextImageCacheService = lt(), this._textMeasurer = N(e);
  }
  async drawImage(t, e, i, n, r, a, c, l, d, f, y) {
    if (f <= 0)
      return;
    this.resetStyles();
    const x = this.ctx, p = await this.getOrCreateImage(t, () => {
      const v = new Blob([t.data], { type: "image/png" });
      return createImageBitmap(v);
    });
    x.imageSmoothingEnabled = y, x.drawImage(
      p,
      e,
      i,
      n,
      r,
      R(a, 0),
      R(c, 0),
      R(l, 0),
      R(d, 0)
    );
  }
  /**
   * Draws line segments.
   * @param points The points.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawLineSegments(t, e, i, n, r, a) {
    if (t.length < 2 || e.isInvisible() || i == 0)
      return;
    this.resetStyles();
    const c = this.ctx;
    c.beginPath(), this.applyLineStyle(e, i, n, r, a);
    for (let l = 0; l < t.length; l += 2) {
      const d = t[l], f = t[l + 1];
      this.drawPoints([d, f]);
    }
    c.stroke();
  }
  async drawLine(t, e, i, n, r, a) {
    if (t.length < 2 || e.isInvisible() || i == 0)
      return;
    this.resetStyles();
    const c = this.ctx;
    c.beginPath(), this.applyLineStyle(e, i, n, r, a), this.drawPoints(t), c.stroke();
  }
  /**
   * Draws a polygon.
   * @param points The points.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygon(t, e, i, n, r, a, c) {
    if (e.isInvisible() && !(i.isVisible() || n <= 0) || t.length < 2)
      return;
    this.resetStyles();
    const l = this.ctx;
    l.beginPath(), this.applyPolygonStyle(e, i, n, r, a, c), this.drawPoints(t), l.closePath(), e.isVisible() && l.fill(), i.isVisible() && n > 0 && l.stroke();
  }
  /**
   * Draws multiple polygons.
   * @param polygons The polygons.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygons(t, e, i, n, r, a, c) {
    if (e.isInvisible() && !(i.isVisible() || n <= 0) || t.length === 0)
      return;
    this.resetStyles();
    const l = this.ctx;
    this.applyPolygonStyle(e, i, n, r, a, c);
    for (const d of t)
      d.length < 2 || (l.beginPath(), this.drawPoints(d), l.closePath(), e.isVisible() && l.fill(), i.isVisible() && n > 0 && l.stroke());
  }
  /**
   * Draws the text.
   * @param p The position of the text.
   * @param text The text.
   * @param fill The fill color.
   * @param fontFamily The font family.
   * @param fontSize Size of the font.
   * @param fontWeight The font weight.
   * @param rotation The rotation angle.
   * @param horizontalAlignment The horizontal alignment.
   * @param verticalAlignment The vertical alignment.
   * @param maxSize The maximum size of the text.
   */
  async drawText(t, e, i, n, r, a, c, l, d, f) {
    if (!e || i.isInvisible())
      return;
    E(l) && (l = T.Left), E(d) && (d = C.Top), this.resetStyles();
    const y = this.ctx;
    r = r || 12, a = a || L.Normal, this.applyTextStyle(i, n, r, a), y.save(), y.translate(t.x, t.y), c && y.rotate(c * (Math.PI / 180));
    const x = K.splitLines(e), p = [];
    for (const u of x) {
      const _ = this.measureText(u, n, r, a);
      p.push(_);
    }
    const v = p.reduce((u, _) => u + _.height, 0);
    let g = 0;
    y.textBaseline = "middle", d === C.Top ? g = 0 : d === C.Middle ? g = -v / 2 : d === C.Bottom && (g = -v);
    for (let u = 0; u < x.length; u++) {
      const _ = x[u];
      let m = 0;
      const w = p[u];
      l === T.Center ? m = -w.width / 2 : l === T.Right && (m = -w.width), y.fillText(_, m, g + w.height / 2, f == null ? void 0 : f.width), g += w.height;
    }
    y.restore();
  }
  measureText(t, e, i, n) {
    return this._textMeasurer.measureText(t, e, i, n);
  }
  setClip(t) {
    this.ctx.save();
    const e = new Path2D();
    e.rect(t.left, t.top, t.width, t.height), this.ctx.clip(e);
  }
  resetClip() {
    this.ctx.restore();
  }
  resetStyles() {
    const t = this.ctx;
    t.setLineDash([]), Object.assign(t, this._ctxInitStyles);
  }
  applyLineStyle(t, e, i, n, r) {
    const a = this.ctx;
    n && n.length > 0 && a.setLineDash(n), a.lineWidth = e, a.lineJoin = this.styleConverter.convertLineJoin(r), a.strokeStyle = this.styleConverter.convertStrokeOrFillStyle(t);
  }
  applyPolygonStyle(t, e, i, n, r, a) {
    e.isVisible() && i > 0 && this.applyLineStyle(e, i, n, r, a), t.isVisible() && (this.ctx.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t));
  }
  applyTextStyle(t, e, i, n) {
    const r = this.ctx;
    r.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t), r.font = this.styleConverter.convertFont(e, i, n);
  }
  drawPoints(t) {
    this.ctx.moveTo(t[0].x, t[0].y);
    for (let e = 1; e < t.length; e++) {
      const i = t[e];
      this.ctx.lineTo(i.x, i.y);
    }
  }
  async getOrCreateImage(t, e) {
    const i = t.getHashCode().toString(), n = this._renderContextImageCacheService.get(i);
    if (n)
      return Promise.resolve(n);
    const r = await e();
    return this._renderContextImageCacheService.set(i, r), r;
  }
}
class ft extends V {
  constructor(t) {
    super();
    h(this, "_view");
    h(this, "_tooltip");
    h(this, "_renderContext");
    h(this, "_drawCtx");
    h(this, "_styleConverter", new B());
    if (this._view = t, this._drawCtx = this._view.getContext("2d"), !this._drawCtx)
      throw new Error("Could not get 2d context");
    this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", document.body.appendChild(this._tooltip), this._renderContext = new at(this._view), Z(this._view, this);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return new S(0, 0, this._view.width, this._view.height);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const e = t.toString() || "";
    if (e.trim().length === 0)
      return;
    const i = this._view.offsetTop, n = this._view.offsetLeft;
    this._tooltip.innerText = e, this._tooltip.style.top = `${i + t.position.y}px`, this._tooltip.style.left = `${n + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = X(t);
  }
  async renderOverride(t) {
    this._drawCtx = this._view.getContext("2d");
    const e = this._view;
    if (this._drawCtx.reset(), t.background.isUndefined() || (this._drawCtx.fillStyle = this._styleConverter.convertStrokeOrFillStyle(t.background), this._drawCtx.fillRect(0, 0, e.width, e.height)), await t.render(this._renderContext, new S(0, 0, e.width, e.height)), this._zoomRectangle && this._zoomRectangle.equals(S.Empty)) {
      const i = W.parse("#40FFFF00"), n = $.Black;
      await this._renderContext.drawRectangle(this._zoomRectangle, i, n, 1, G.Automatic);
    }
  }
}
class ht extends J {
  constructor(t) {
    super();
    h(this, "_pdf");
    h(this, "ctx");
    h(this, "_textMeasurer");
    h(this, "styleConverter", new B());
    h(this, "_ctxInitStyles");
    this._pdf = new U({
      unit: "px",
      orientation: t
    });
    const e = this._pdf.context2d;
    this.ctx = e, this._ctxInitStyles = {
      fillStyle: e.fillStyle,
      strokeStyle: e.strokeStyle,
      lineJoin: e.lineJoin,
      lineWidth: e.lineWidth
    }, this._textMeasurer = N();
  }
  getPdf() {
    return this._pdf;
  }
  async drawImage(t, e, i, n, r, a, c, l, d, f, y) {
    if (f <= 0)
      return;
    const x = a - e / n * l, p = t.width / n * l, v = c - i / r * d, g = t.height / r * d;
    this.clearStyles(), this._pdf.addImage(t.data, "PNG", x, v, p, g);
  }
  /**
   * Draws line segments.
   * @param points The points.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawLineSegments(t, e, i, n, r, a) {
    if (t.length < 2 || e.isInvisible() || i == 0)
      return;
    this.clearStyles();
    const c = this.ctx;
    c.beginPath(), this.applyLineStyle(e, i, n, r, a);
    for (let l = 0; l < t.length; l += 2) {
      const d = t[l], f = t[l + 1];
      this.drawPoints([d, f]);
    }
    c.stroke();
  }
  async drawLine(t, e, i, n, r, a) {
    if (t.length < 2 || e.isInvisible() || i == 0)
      return;
    this.clearStyles();
    const c = this.ctx;
    c.beginPath(), this.applyLineStyle(e, i, n, r, a), this.drawPoints(t), c.stroke();
  }
  /**
   * Draws a polygon.
   * @param points The points.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygon(t, e, i, n, r, a, c) {
    if (e.isInvisible() && !(i.isVisible() || n <= 0) || t.length < 2)
      return;
    this.clearStyles();
    const l = this.ctx;
    if (e.a < 255 || i.a < 255) {
      this._pdf.saveGraphicsState();
      let d = 1, f = 1;
      e.a < 255 && (d = e.a / 255), i.a < 255 && (f = i.a / 255), this._pdf.setGState(this._pdf.GState({ opacity: d, "stroke-opacity": f }));
    }
    l.beginPath(), this.applyPolygonStyle(e, i, n, r, a, c), this.drawPoints(t), l.closePath(), e.isVisible() && l.fill(), i.isVisible() && n > 0 && l.stroke(), (e.a < 255 || i.a < 255) && this._pdf.restoreGraphicsState();
  }
  /**
   * Draws multiple polygons.
   * @param polygons The polygons.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygons(t, e, i, n, r, a, c) {
    if (e.isInvisible() && !(i.isVisible() || n <= 0) || t.length === 0)
      return;
    this.clearStyles();
    const l = this.ctx;
    this.applyPolygonStyle(e, i, n, r, a, c);
    for (const d of t)
      d.length < 2 || (l.beginPath(), this.drawPoints(d), l.closePath(), e.isVisible() && l.fill(), i.isVisible() && n > 0 && l.stroke());
  }
  /**
   * Draws the text.
   * @param p The position of the text.
   * @param text The text.
   * @param fill The fill color.
   * @param fontFamily The font family.
   * @param fontSize Size of the font.
   * @param fontWeight The font weight.
   * @param rotation The rotation angle.
   * @param horizontalAlignment The horizontal alignment.
   * @param verticalAlignment The vertical alignment.
   * @param maxSize The maximum size of the text.
   */
  async drawText(t, e, i, n, r, a, c, l, d, f) {
    if (!e || i.isInvisible())
      return;
    this.clearStyles(), E(l) && (l = T.Left), E(d) && (d = C.Top);
    const y = this.ctx;
    r = r || 12, a = a || L.Normal, this.applyTextStyle(i, n, r, a), y.save(), y.translate(t.x, t.y), c && y.rotate(c * (Math.PI / 180));
    const x = K.splitLines(e), p = [];
    for (const u of x) {
      const _ = this.measureText(u, n, r, a);
      p.push(_);
    }
    const v = p.reduce((u, _) => u + _.height, 0);
    let g = 0;
    y.textBaseline = "middle", d === C.Top ? g = 0 : d === C.Middle ? g = -v / 2 : d === C.Bottom && (g = -v);
    for (let u = 0; u < x.length; u++) {
      const _ = x[u];
      let m = 0;
      const w = p[u];
      l === T.Center ? m = -w.width / 2 : l === T.Right && (m = -w.width), y.fillText(_, m, g + w.height / 2), g += w.height;
    }
    y.restore();
  }
  measureText(t, e, i, n) {
    return this._textMeasurer.measureText(t, e, i, n);
  }
  setClip(t) {
    this.ctx.save(), this.ctx.rect(t.left, t.top, t.width, t.height), this.ctx.clip();
  }
  resetClip() {
    this.ctx.restore();
  }
  applyLineStyle(t, e, i, n, r) {
    const a = this.ctx;
    n && n.length > 0 && a.setLineDash(n), a.lineWidth = e, a.lineJoin = this.styleConverter.convertLineJoin(r), a.strokeStyle = this.styleConverter.convertStrokeOrFillStyle(t);
  }
  clearStyles() {
    this.ctx.setLineDash([]);
  }
  applyPolygonStyle(t, e, i, n, r, a) {
    e.isVisible() && i > 0 && this.applyLineStyle(e, i, n, r, a), t.isVisible() && (this.ctx.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t));
  }
  applyTextStyle(t, e, i, n) {
    const r = this.ctx;
    r.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t), r.font = this.styleConverter.convertFont(e, i, n);
  }
  drawPoints(t) {
    this.ctx.moveTo(t[0].x, t[0].y);
    for (let e = 1; e < t.length; e++) {
      const i = t[e];
      this.ctx.lineTo(i.x, i.y);
    }
  }
}
class gt extends V {
  constructor(t) {
    super();
    h(this, "_view");
    h(this, "_orientation", "portrait");
    h(this, "_clientArea", S.Empty);
    this._view = t, this.calcClientArea();
  }
  get orientation() {
    return this._orientation;
  }
  set orientation(t) {
    t !== this._orientation && (this._orientation = t, this.calcClientArea());
  }
  calcClientArea() {
    const t = new U({
      unit: "px",
      orientation: this.orientation
    }), e = new z(t.internal.pageSize.width, t.internal.pageSize.height);
    t.close(), this._clientArea = S.fromScreenPointAndSize(Q, e);
  }
  get clientArea() {
    return this._clientArea;
  }
  async renderOverride(t) {
    const e = new ht(this.orientation);
    await t.render(e, this.clientArea);
    const i = e.getPdf();
    i.internal.pages.length > 1 && i.deletePage(1);
    const n = i.output("dataurlstring", {
      filename: t.title + ".pdf"
    });
    this._view.src = "", this._view.src = n;
  }
}
class xt extends V {
  constructor(t) {
    super();
    h(this, "_view");
    h(this, "_tooltip");
    //private readonly _drawCtx: HTMLElement
    h(this, "textMeasurer");
    this._view = t, this.textMeasurer = N(), this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", document.body.appendChild(this._tooltip), Z(this._view, this);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return new S(0, 0, this._view.clientWidth, this._view.clientHeight);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const e = t.toString() || "";
    if (e.trim().length === 0)
      return;
    const i = this._view.offsetTop, n = this._view.offsetLeft;
    this._tooltip.innerText = e, this._tooltip.style.top = `${i + t.position.y}px`, this._tooltip.style.left = `${n + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = X(t);
  }
  async renderOverride(t) {
    const e = this._view;
    this._view.innerHTML = "";
    const i = new H(
      e.clientWidth,
      e.clientHeight,
      !0,
      this.textMeasurer,
      t.background
    );
    if (t.background.isUndefined() || (this._view.style.backgroundColor = t.background.toString()), await t.render(i, new S(0, 0, e.clientWidth, e.clientHeight)), this._zoomRectangle && this._zoomRectangle.equals(S.Empty)) {
      const n = W.parse("#40FFFF00"), r = $.Black;
      await i.drawRectangle(this._zoomRectangle, n, r, 1, G.Automatic);
    }
    i.complete(), this._view.innerHTML = i.getXml();
  }
}
export {
  ft as CanvasPlotView,
  gt as PdfPlotView,
  xt as SvgPlotView,
  lt as getRenderContextImageCacheService,
  yt as setRenderContextImageCacheService
};
