/**
 * create images frequently will cause canvas flickering
 * So we mush cache the images somewhere
 */
export interface IRenderContextImageCacheService {
    get(key: string): ImageBitmap | HTMLImageElement;
    set(key: string, value: ImageBitmap | HTMLImageElement): void;
    clear(key?: string): void;
}
export declare function getRenderContextImageCacheService(): IRenderContextImageCacheService;
export declare function setRenderContextImageCacheService(service: IRenderContextImageCacheService): void;
//# sourceMappingURL=RenderContextImageCacheService.d.ts.map