import { CursorType, OxyRect, PlotModel, TrackerHitResult } from 'oxyplot-js';
import { WebPlotViewBase } from './WebPlotViewBase';
export declare class SvgPlotView extends WebPlotViewBase {
    private readonly _view;
    private readonly _tooltip;
    private readonly textMeasurer;
    constructor(view: HTMLDivElement);
    get tooltip(): HTMLElement;
    get clientArea(): OxyRect;
    hideTracker(): void;
    showTracker(trackerHitResult: TrackerHitResult): void;
    setCursorType(cursorType: CursorType): void;
    renderOverride(model: PlotModel): Promise<void>;
}
//# sourceMappingURL=SvgPlotView.d.ts.map