import { CursorType, OxyRect, PlotModel, TrackerHitResult } from 'oxyplot-js';
import { WebPlotViewBase } from './WebPlotViewBase';
export declare class CanvasPlotView extends WebPlotViewBase {
    private readonly _view;
    private readonly _tooltip;
    private readonly _renderContext;
    private _drawCtx;
    private readonly _styleConverter;
    constructor(view: HTMLCanvasElement);
    get tooltip(): HTMLElement;
    get clientArea(): OxyRect;
    hideTracker(): void;
    showTracker(trackerHitResult: TrackerHitResult): void;
    setCursorType(cursorType: CursorType): void;
    renderOverride(model: PlotModel): Promise<void>;
}
//# sourceMappingURL=CanvasPlotView.d.ts.map